<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class ClassOfAccount extends Model
{
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'class_of_accounts';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];

    public function account_master()
    {
        return $this->hasMany('App\AccountMaster', 'class_of_account_id', 'id');
    }

    public function customer()
    {
        return $this->belongsTo(Customer::class, 'class_of_account_id', 'id');
    }
    public function supplier()
    {
        return $this->belongsTo(Supplier::class, 'class_of_account_id', 'id');
    }
    public function StaffAndSalesman()
    {
        return $this->belongsTo(StaffAndSalesman::class, 'class_of_account_id', 'id');
    }
    public function Expense()
    {
        return $this->belongsTo(Expense::class, 'class_of_account_id', 'id');
    }
    public function AdminOtherAccount()
    {
        return $this->belongsTo(AdminOtherAccount::class, 'class_of_account_id', 'id');
    }
}
