@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="row mt-4 mb-1">
                <div class="col-md-6">
                    <h6 class="card-title mb-4 titlcust">View Journal Voucher</h6>
                </div>
                <div class="col-md-6">
                    <a href="">
                        <button class="btn btn-outline-primary float-right cust-btn1" onclick="printPageArea('printableArea')"
                            type="submit">Print Document
                        </button>
                    </a>
                    <a href="">
                        <button class="btn btn-outline-primary float-right" type="submit">Back
                        </button>
                    </a>
                </div>
            </div>

            <div class="card" id="printableArea">
                <div class="card-body">

                    <h6 class="card-title mb-1 text-center font-size-20">Journal Voucher</h6>
                    <br>


                    @if (!empty(($companyLogo = auth()->user()->company_logo)))
                    <div class="col-md-12 d-flex align-items-center justify-content-center">
                        <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                            alt="logo" width="270px">
                        </div>
                    @else
                    <div class="col-md-12 d-flex align-items-center justify-content-center mb-3">
                        <img src="{{ asset('assets/images/acp-logo.svg') }}" class="img-fluid" alt="logo"
                            width="270px">
                    </div>
                    @endif

                    <div class="row">
                        <div class="col-md-9 pt-2" style="border-top: solid;border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company Name: </strong> {{ $company->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch Name: </strong> {{ session()->get('branch')->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch Address</strong> {{ session()->get('branch')->address }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company Country</strong> {{ $company->country }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company CR Number</strong> {{ $company->cr_number }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company VAT Number</strong> {{ $company->vat_number }}</p>
                        </div>
                        <div class="col-md-3 pt-2" style="border-top: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Date : </strong> {{ $journalVoucher[0]->date }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Journal Voucher # : </strong> {{ $journalVoucher[0]->invoice_no }}</p>
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Mode/Term of Payment : </strong> {{ $journalVoucher[0]->term_of_payment }}</p> --}}
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO Number(Supplier) : </strong> {{ $journalVoucher[0]->lpo_no }}</p> --}}
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Journal Voucher Number : </strong> {{ $journalVoucher[0]->po_no ?? '' }}</p> --}}
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO(DUE DAYS) : </strong> {{ $journalVoucher[0]->lpo_days }}</p> --}}
                        </div>
                        <div class="col-md-12" style="border-left: solid;border-right: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Client; </strong> </p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Account Name : </strong> {{ $journalVoucher[0]->account->name_of_organisation ?? ($journalVoucher[0]->account->account_name ?? $journalVoucher[0]->account->first_name . ' ' . $journalVoucher[0]->account->last_name) }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Email :</strong> {{ $journalVoucher[0]->account->email ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Contact Person Name : </strong>{{ $journalVoucher[0]->account->contact_person_name ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>Contact Number : </strong>{{ $journalVoucher[0]->account->mobile ?? 'No Record Found' }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0;"><strong>VAT Number : </strong>{{ $journalVoucher[0]->account->vat_number ?? 'No Record Found' }}</p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="table-responsive mb-0 pb-0" >
                            <table class="table table-striped table-bordered dt-responsive nowrap mb-0" style="border-bottom: solid;border-left: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                                <thead >
                                    <tr style="background-color: black;color:white;border-color: black">
                                        <th style="border: none">Account Name</th>
                                        <th style="border: none">Narrations</th>
                                        <th style="border: none">Debit/Credit</th>
                                        <th style="border: none">Amount</th>
                                    </tr>
                                </thead>
                                <tbody id="table-body" >
                                    @foreach ($journalVoucher as $key=>$voucher)
                                   <tr>
                                        <td class="border border-dark">{{ $voucher->account->name_of_organisation ?? $voucher->account->account_name }}</td>
                                        <td class="border border-dark">{{ $voucher->narration }}</td>
                                        <td class="border border-dark">{{ $voucher->type }}</td>
                                        <td class="border border-dark">{{ number_format($voucher->amount, session('branch')->currency_decimal) }}</td>
                                   </tr>
                                   @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-8 pt-2" style="border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0">{!! session()->get('branch')->payment_details !!}</p>
                        </div>
                        <div class="col-md-2 pt-2" style="border-right: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Debit Amount: </strong></p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Credit Amount : </strong></p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Difference : </strong></p>
                        </div>
                        <div class="col-md-2 pt-2" style="border-right: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;">{{ number_format($journalVoucher[0]->amount, session('branch')->currency_decimal) }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;">{{ number_format($journalVoucher[0]->amount, session('branch')->currency_decimal) }}</p>
                            <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;">{{ number_format(0, session('branch')->currency_decimal) }}</p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end" style="border-bottom: solid; border-left: solid; border-color: black; padding: 0; height: 150px;">
                            <p class="text-dark font-weight-bold text-left" style="padding: 5px; margin: 0;"><strong>Client Signature & Stamp</strong></p>
                        </div>


                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end" style="border-bottom: solid;border-right: solid;border-color: black;padding: 0;height: 150px;">
                            <p class="text-dark font-weight-bold mt-5 text-right" style="padding: 5px;margin:0"><strong>{{ $company->name }}</strong></p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12 pt-2 d-flex flex-column justify-content-center alien-item-center" >
                            <p class="text-dark font-weight-bold text-center" style="padding: 5px; margin: 0;"><strong>Generated by Ledgematic</strong></p>
                        </div>
                    </div>


                    {{-- <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table class="table table-bordered dt-responsive nowrap">
                            <tr>
                                <td>
                                    <table class="table table-bordered dt-responsive nowrap">
                                        <tr>
                                            <td>
                                                @if (!empty(($companyLogo = auth()->user()->company_logo)))
                                                <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                    <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                                                        alt="logo" width="700px">
                                                    </div>
                                                @else
                                                    <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                        <img src="{{ asset('assets/images/acp-logo.png') }}" class="img-fluid" alt="logo"
                                                            width="700px">
                                                    </div>
                                                @endif
                                            </td>
                                            <td colspan="2">
                                                <div class="row">
                                                    <div class="col-md-12 ">
                                                        <label>Company Name :</label>
                                                        <span>{{ $company->name }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Branch Name :</label>
                                                        <span>{{ session()->get('branch')->name }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Branch Address :</label>
                                                        <span>{{ session()->get('branch')->address }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company Country :</label>
                                                        <span>{{ $company->country }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company CR Number :</label>
                                                        <span>{{ $company->cr_number }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Company Vat Number :</label>
                                                        <span>{{ $company->vat_number }}</span>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>

                                            </td>
                                            <td>
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <h5>Buyer</h5>
                                                    </div>
                                                        <div class="col-md-12">
                                                            <label>Account Name :</label>
                                                            <span>{{ $journalVoucher[0]->account->name_of_organisation ?? ($journalVoucher[0]->account->account_name ?? $journalVoucher[0]->account->first_name . ' ' . $journalVoucher[0]->account->last_name) }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Email :</label>
                                                            <span>{{ $journalVoucher[0]->account->email ?? 'No Record Found' }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Contact Person Name :</label>
                                                            <span>{{ $journalVoucher[0]->account->contact_person_name ?? 'No Record Found' }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Contact Number :</label>
                                                            <span>{{ $journalVoucher[0]->account->mobile ?? 'No Record Found' }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>VAT Number :</label>
                                                            <span>{{ $journalVoucher[0]->account->vat_number ?? 'No Record Found' }}</span>
                                                        </div>
                                                </div>
                                            </td>


                                        </tr>
                                    </table>
                                </td>
                                <td>
                                    <table class="table table-bordered dt-responsive nowrap">
                                        <tr>
                                            <td>
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <label>Purchase Invoice # :</label>
                                                        <span>{{ $journalVoucher[0]->invoice_no }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>Mode/Term of Payment :</label>
                                                        <span>{{ $journalVoucher[0]->term_of_payment }}</span>
                                                    </div>

                                                    <div class="col-md-12">
                                                        <label>Date :</label>
                                                        <span>{{ $journalVoucher[0]->date }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>LPO Number(Supplier) :</label>
                                                        <span>{{ $journalVoucher[0]->lpo_no }}</span>
                                                    </div>

                                                    <div class="col-md-12">
                                                        <label>Purchase Order Number :</label>
                                                        <span>{{ $journalVoucher[0]->po_no ?? '' }}</span>
                                                    </div>
                                                    <div class="col-md-12">
                                                        <label>LPO(DUE DAYS) :</label>
                                                        <span>{{ $journalVoucher[0]->lpo_days }}</span>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>

                                </table>
                                </td>
                            </tr>
                        </table>
                    </div>

                    <br>


                    <div class="row">
                        <div class="table-responsive mb-0" data-pattern="priority-columns">
                            <table class="table table-bordered dt-responsive nowrap"
                                style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                <thead>
                                    <tr>
                                        <th>S No.</th>
                                        <th>Account Name</th>
                                        <th>Narrations</th>
                                        <th>Debit/Credit</th>
                                        <th>Amount</th>
                                    </tr>
                                </thead>

                                <tbody id="table-body">
                                    @forelse ($journalVoucher as $key=>$voucher)
                                        <tr>
                                            <td>{{ $key + 1 }}</td>
                                            <td>
                                                <p>{{ $voucher->account->name_of_organisation ?? $voucher->account->account_name }}
                                                </p>
                                            </td>
                                            <td>
                                                <p>{{ $voucher->narration }}</p>
                                            </td>
                                            <td>
                                                <p>{{ $voucher->type }}</p>
                                            </td>
                                            <td>
                                                <p>{{ $voucher->amount }}</p>
                                            </td>
                                        </tr>
                                    @empty
                                    @endforelse
                                    <tr>
                                        <td></td>
                                        <td>Grand Total</td>
                                        <td></td>
                                        <td></td>
                                        <td id="grand-total"></td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <br>


                    <div class="row">
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                            <strong>
                                <label>Debit Amount:</label>
                                <span id="total-debit-amount">0.000
                                </span>
                            </strong>
                        </div>
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                            <strong>
                                <label>Credit Amount :</label>
                                <span id="total-credit-amount">0.000
                                </span>
                            </strong>
                        </div>
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                            <strong>
                                <label>Difference :</label>
                                <span id="total-difference-amount">0.000
                                </span>
                            </strong>
                        </div>
                        <div class="col-md-8">
                        </div>
                        <div class="col-md-4">
                        </div>
                    </div> --}}



                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->

    <script>
        document.addEventListener("DOMContentLoaded", function() {
            // Initialize total amounts
            let totalDebitAmount = 0;
            let totalCreditAmount = 0;

            // Extract journal voucher data from Blade's inline PHP
            const journalVoucher = @json($journalVoucher);

            // Loop through journal vouchers to calculate debit and credit totals
            journalVoucher.forEach(function(voucher) {
                const voucherAmount = parseFloat(voucher.amount);
                const voucherType = voucher.type;

                if (voucherType === "debit") {
                    totalDebitAmount += voucherAmount;
                } else if (voucherType === "credit") {
                    totalCreditAmount += voucherAmount;
                }
            });

            // Calculate the difference between debit and credit
            const totalDifferenceAmount = totalDebitAmount - totalCreditAmount;

            // Update the elements with the calculated values
            document.getElementById("total-debit-amount").textContent = totalDebitAmount.toFixed(2);
            document.getElementById("total-credit-amount").textContent = totalCreditAmount.toFixed(2);
            document.getElementById("total-difference-amount").textContent = totalDifferenceAmount.toFixed(2);

            // Calculate the grand total
            const grandTotal = totalDebitAmount + totalCreditAmount;
            document.getElementById("grand-total").textContent = grandTotal.toFixed(2);
        });
    </script>





    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
@endsection
