@extends('layouts.crusher')
@section('content')
@php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branche = Branches::where('id', $selectedBranchId)->first();

@endphp
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Sales Invoice</h6>
                        </div>
                        <div class="col-md-6">
                            <a href="{{ route('software.admin_sales_invoice.create') }} ">
                                <button class="btn btn-cust1 float-right" type="submit">Create Sales Invoice
                                </button>
                            </a>
                        </div>
                    </div>
                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="datatable" class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Sale Voucher Number</th>
                                    <th>Amount</th>
                                    <th>Action</th>
                                </tr>
                            </thead>

                            <tbody>
                                @forelse ($salesInvoice as $si)
                                    {{-- @dd($si)     --}}
                                    <tr>
                                        <td>{{ $si->date }}</td>
                                        <td>{{ $si->invoice_no }}</td>
                                        {{-- <td>{{ $si->total_net_amount }}</td> --}}
                                        @if (!$si->trashed())
                                        <td>{{ number_format($si->total_gross_amount, session('branch')->currency_decimal) }}</td>
                                        @else
                                            <td>-</td>
                                        @endif
                                        <td>
                                            @if (
                                                !empty(($branchId = session()->get('selected_branch'))) &&
                                                    Branches::hasBranchPermission($branchId, 'view-print-sales-invoice'))
                                                <a
                                                    href="{{ route('software.admin_sales_invoice.show', ['admin_sales_invoice' => $si->id]) }}">
                                                    <i class="far fa-eye cust-icon2"></i></a>
                                            @endif
                                            @if (!$si->trashed())
                                                @if (
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'edit-sales-invoice'))
                                                    <a
                                                        href="{{ route('software.admin_sales_invoice.edit', ['admin_sales_invoice' => $si->id]) }}">
                                                        <i class="far fa-edit cust-icon2"></i></a>
                                                @endif
                                                @if (
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'cancel-sales-invoice'))
                                                <form
                                                    action="{{ route('software.sales.invoice.delete', ['sale_invoice' => $si->id]) }}"
                                                    method="POST" class="d-inline">
                                                    @csrf
                                                    @method('DELETE')
                                                    <button onclick="return confirm('Sure want to delete?')" type="submit"
                                                        class="btn btn-link p-0 m-0 text-danger">
                                                        <i class="far fa-window-close cust-icon2"></i>
                                                    </button>
                                                </form>
                                                @endif

                                                <a href="{{ route('software.credit_notes.create', ['si' => $si->invoice_no]) }}"
                                                    class="cust-btn3">
                                                    <button type="button" class="btn btn-outline-primary">Create Credit
                                                        Note</button>
                                                </a>
                                            @else
                                                <span class="text-danger">Deleted</span>
                                            @endif
                                        </td>
                                    </tr>
                                @empty
                                @endforelse
                            </tbody>
                        </table>
                    </div>

                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
@endsection
