<?php $__env->startSection('content'); ?>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Ledger Report</h6>
                        </div>

                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="">
                                <?php if($ledger_class): ?>
                                    <?php echo e($ledger_class); ?>

                                <?php else: ?>
                                    No Account name available.
                                <?php endif; ?>
                            </h6>
                            <h6 class="">Date: <span><?php echo e(date('d/m,Y', strtotime($from_date))); ?>

                            </span> To <span><?php echo e(date('d/m,Y', strtotime($to_date))); ?></span>
                            </h6>
                        </div>
                        <div class="col-md-6">
                            <div class="btn-group float-right" role="group" aria-label="Basic example">
                                <a href="" type="button" class="btn btn-outline-primary"><i
                                        class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                <a onclick="printPageArea('printableArea')" class="btn btn-outline-primary"> Print & PDF
                                    Formate</a>

                            </div>
                        </div>
                    </div>
                    <br>
                    <!-- <div class="col-4"> -->
                    <div class="row">

                        <div class="col-md-12">
                            <div id="printableArea" class="table-responsive mb-0" data-pattern="priority-columns">
                                <table class="table table-bordered nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>Date</th>
                                            <th>Voucher Description</th>
                                            <th>Debit</th>
                                            <th>Credit</th>
                                        </tr>
                                    </thead>

                                    <tbody>
                                        <?php
                                        $debitTotal = 0;
                                        $creditTotal = 0;
                                        $PurchaesInvoiceTotal = 0;
                                        $SaleInvoiceTotal = 0;
                                        $JournalVoucherTotalForDebit = 0;
                                        $JournalVoucherTotalForCredit = 0;
                                        $ReceiptVoucherTotalForCash = 0;
                                        $ReceiptVoucherTotalForBank = 0;
                                        $PaymentVoucherTotalForCash = 0;
                                        $PaymentVoucherTotalForBank = 0;
                                        $CreditNoteTotal = 0;
                                        $DebitNoteTotal = 0;
                                        $DeliveryNoteTotal = 0;
                                        $PurchaseOrderTotal = 0;
                                        $QuotationTotal = 0;
                                        $CreateOpeningBalance = 0;
                                        ?>

                                        <?php if($CreateDebitOpeningBalance || $CreateCreditOpeningBalance): ?>
                                            <tr>
                                                <td><?php echo e(optional($matchedAccount)->date); ?></td>
                                                <td>Create Opening balance #</td>
                                                <td>
                                                    <?php if($CreateDebitOpeningBalance): ?>
                                                        <?php echo e($CreateDebitOpeningBalance); ?>

                                                    <?php endif; ?>
                                                </td>
                                                <td>
                                                    <?php if($CreateCreditOpeningBalance): ?>
                                                        <?php echo e($CreateCreditOpeningBalance); ?>

                                                    <?php endif; ?>
                                                </td>
                                            </tr>
                                        <?php endif; ?>

                                        <?php $__currentLoopData = $allData->sortBy('date'); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $data): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                    <?php if(is_object($data)): ?>
                                    <tr>
                                        <td>
                                            <?php if($data instanceof \App\AdminSalesInvoice): ?>
                                                <?php echo e($data->date); ?>

                                            <?php elseif($data instanceof \App\CreditNote): ?>
                                                <?php echo e($data->date); ?>

                                            <?php elseif($data instanceof \App\DebitNote): ?>
                                                <?php echo e($data->date); ?>

                                            <?php elseif($data instanceof \App\ReceiptVoucherExpense): ?>
                                                <?php echo e($data->date); ?>

                                            <?php elseif($data instanceof \App\PaymentVoucherExpense): ?>
                                                <?php echo e($data->date); ?>

                                            <?php elseif($data instanceof \App\AdminPurchaesInvoice): ?>
                                                <?php echo e($data->date); ?>

                                            <?php elseif($data instanceof \App\AdminJournalVoucher): ?>
                                                <?php echo e($data->date); ?>

                                            <?php elseif($data instanceof \App\Quotation): ?>
                                                <?php echo e($data->date); ?>

                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            <?php if($data instanceof \App\AdminSalesInvoice): ?>
                                                <span><strong><a href="<?php echo e(route('software.admin_sales_invoice.show', ['admin_sales_invoice' => $data->id])); ?>">Sales#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php elseif($data instanceof \App\CreditNote): ?>
                                                <span><strong><a href="<?php echo e(route('software.credit_notes.show', ['credit_note' => $data->id])); ?>">Credit Note#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php elseif($data instanceof \App\DebitNote): ?>
                                                <span><strong><a href="<?php echo e(route('software.debit_notes.show', ['debit_note' => $data->id])); ?>">Debit Note#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php elseif($data instanceof \App\ReceiptVoucherExpense): ?>
                                                <span><strong><a href="<?php echo e(route('software.receipt_vouchers.show', ['receipt_voucher' => $data->receipt_id])); ?>">Receipt#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php elseif($data instanceof \App\PaymentVoucherExpense): ?>
                                                <span><strong><a href="<?php echo e(route('software.payment_vouchers.show', ['payment_voucher' => $data->voucher_id])); ?>">Payment#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php elseif($data instanceof \App\AdminPurchaesInvoice): ?>
                                                <span><strong><a href="<?php echo e(route('software.purchase_invoices.show', ['purchase_invoice' => $data->id])); ?>">Purchase#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php elseif($data instanceof \App\AdminJournalVoucher): ?>
                                                <span><strong><a href="<?php echo e(route('software.journal_vouchers.show', ['journal_voucher' => $data->id])); ?>">Journal#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php elseif($data instanceof \App\Quotation): ?>
                                                <span><strong><a href="<?php echo e(route('software.quotations.show', ['quotation' => $data->id])); ?>">Quatation#
                                                    <?php echo e($data->invoice_no); ?></a></strong></span>
                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            <?php if($data instanceof \App\AdminSalesInvoice): ?>
                                                <?php echo e(number_format($data->total_net_amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $SaleInvoiceTotal += $data->total_net_amount;
                                                ?>
                                            <?php elseif($data instanceof \App\DebitNote): ?>
                                                <?php echo e(number_format($data->total_net_amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $DebitNoteTotal += $data->total_net_amount;
                                                ?>
                                            <?php elseif($data instanceof \App\AdminJournalVoucher && $data->type === 'debit'): ?>
                                                <?php echo e(number_format($data->amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $JournalVoucherTotalForDebit += $data->amount;
                                                ?>
                                            <?php elseif($data instanceof \App\Quotation): ?>
                                                <?php echo e(number_format($data->total_net_amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $QuotationTotal += $data->total_net_amount;
                                                ?>

                                                <?php elseif($data instanceof \App\PaymentVoucherExpense && $data->account_name === $ledger_class && $classOfAccountId == 6): ?>
                                                <?php echo e(number_format($data->amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $PaymentVoucherTotalForCash += $data->amount;
                                                ?>
                                                <?php elseif($data instanceof \App\PaymentVoucherExpense && $data->account_name === $ledger_class): ?>
                                                <?php echo e(number_format($data->amount + $data->new_vat_amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $PaymentVoucherTotalForCash += $data->amount + $data->new_vat_amount;
                                                ?>
                                                 <?php elseif($data instanceof \App\ReceiptVoucherExpense && $data->bank_name === $ledger_class): ?>
                                                <?php echo e(number_format($data->amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $ReceiptVoucherTotalForBank += $data->amount;
                                                ?>
                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            <?php if($data instanceof \App\AdminPurchaesInvoice): ?>
                                                <?php echo e(number_format($data->total_purchase_amount_with_cf, session('branch')->currency_decimal)); ?>

                                                <?php
                                                    $PurchaesInvoiceTotal += $data->total_purchase_amount_with_cf;
                                                ?>
                                            <?php elseif($data instanceof \App\CreditNote): ?>
                                                <?php echo e(number_format($data->total_net_amount, session('branch')->currency_decimal)); ?>

                                                <?php
                                                $CreditNoteTotal += $data->total_net_amount;
                                            ?>
                                            <?php elseif($data instanceof \App\ReceiptVoucherExpense && $data->account_name === $ledger_class): ?>
                                            <?php echo e(number_format($data->amount, session('branch')->currency_decimal)); ?>

                                            <?php
                                                $ReceiptVoucherTotalForCash += $data->amount;
                                            ?>
                                            
                                            <?php elseif($data instanceof \App\AdminJournalVoucher && $data->type === 'credit'): ?>
                                            <?php echo e(number_format($data->amount, session('branch')->currency_decimal)); ?>

                                            <?php
                                                $JournalVoucherTotalForCredit += $data->amount;
                                            ?>
                                            <?php elseif($data instanceof \App\PaymentVoucherExpense && $data->bank_name === $ledger_class && $classOfAccountId == 6): ?>
                                            <?php echo e(number_format($data->amount, session('branch')->currency_decimal)); ?>

                                            <?php
                                                $PaymentVoucherTotalForBank += $data->amount;
                                            ?>
                                            <?php elseif($data instanceof \App\PaymentVoucherExpense && $data->bank_name === $ledger_class): ?>
                                            <?php echo e(number_format($data->amount + $data->new_vat_amount, session('branch')->currency_decimal)); ?>

                                            <?php
                                                $PaymentVoucherTotalForBank += $data->amount + $data->new_vat_amount;
                                            ?>
                                            <?php endif; ?>
                                        </td>
                                    </tr>
                                    <?php endif; ?>
                                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>

                                    <?php

                                        $debitTotal = $CreateDebitOpeningBalance + $SaleInvoiceTotal + $JournalVoucherTotalForDebit + $PaymentVoucherTotalForCash + $DebitNoteTotal + $ReceiptVoucherTotalForBank;

                                        $creditTotal = $CreateCreditOpeningBalance + $PurchaesInvoiceTotal + $ReceiptVoucherTotalForCash + $JournalVoucherTotalForCredit + $CreditNoteTotal + $PaymentVoucherTotalForBank;

                                    ?>


                                        <tr>
                                            <td></td>
                                            <td>Opening Balance</td>
                                            <td>
                                                <?php if($DebitopeningBalance !== null && $DebitopeningBalance !== '' && $DebitopeningBalance !== 0): ?>
                                                    <strong><?php echo e(number_format($DebitopeningBalance, session('branch')->currency_decimal)); ?></strong>
                                                <?php else: ?>

                                                <?php endif; ?>
                                            </td>
                                            <td>
                                                <?php if($creditOpeningBalance !== null && $creditOpeningBalance !== '' && $creditOpeningBalance !== 0): ?>
                                                    <strong><?php echo e(number_format($creditOpeningBalance, session('branch')->currency_decimal)); ?></strong>
                                                <?php else: ?>

                                                <?php endif; ?>
                                            </td>
                                        </tr>

                                        <tr>
                                            <td></td>
                                            <td>Current Balance</td>
                                            <td>
                                                <?php if($debitTotal !== null && $debitTotal !== '' && $debitTotal !== 0): ?>
                                                    <strong><?php echo e(number_format($debitTotal, session('branch')->currency_decimal)); ?></strong>
                                                <?php else: ?>

                                                <?php endif; ?>
                                            </td>
                                            <td>
                                                <?php if($creditTotal !== null && $creditTotal !== '' && $creditTotal !== 0): ?>
                                                    <strong><?php echo e(number_format($creditTotal, session('branch')->currency_decimal)); ?></strong>
                                                <?php else: ?>

                                                <?php endif; ?>
                                            </td>
                                        </tr>
                                        <?php
                                        // Closing Balance

                                        $DebitCB = $debitTotal + $DebitopeningBalance;

                                        $CreditCB = $creditTotal + $creditOpeningBalance;

                                        $ClosingBalance = $DebitCB - $CreditCB;

                                        ?>
                                        <tr>
                                            <td></td>
                                            <td>Closing Balance</td>
                                            <td><?php echo e($ClosingBalance >= 0 ? number_format($ClosingBalance, session('branch')->currency_decimal) : ''); ?> </td>
                                            <td><?php echo e($ClosingBalance < 0 ? number_format(abs($ClosingBalance), session('branch')->currency_decimal) : ''); ?></td>
                                        </tr>
                                        <?php if(empty($PurchaesInvoice) && empty($SaleInvoice) && empty($JournalVoucher) && empty($ReceiptVoucher) && empty($PaymentVoucher) && empty($CreditNote) && empty($DebitNote) && empty($PurchaseOrder) && empty($Quotation)): ?>
                                            <tr>
                                                <td colspan="4">No data available</td>
                                            </tr>
                                        <?php endif; ?>
                                    </tbody>
                                </table>
                            </div>
                        </div>

                    </div>


                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.crusher', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH F:\zampp 2 7.4\htdocs\acpnew-repo\resources\views/crusher/reports/ledger-report.blade.php ENDPATH**/ ?>