<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Customer extends Model
{
    // RELATIONS
    public function country()
    {
        return $this->belongsTo(Country::class, 'country_id', 'id');
    }

    public function classOfAccount()
    {
        return $this->belongsTo(ClassOfAccount::class, 'class_of_account_id', 'id');
    }
    public function purchases() {
        return $this->hasMany(AdminPurchaesInvoice::class, 'account_id');
    }
    //
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'customers';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'location_id',
        'transactions_password',
        'opening_balance',
        'report_password',
        'date',
        'name_of_organisation',
        'commerical_registration_number',
        'contact_person_name',
        'office_phone',
        'mobile',
        'whatsapp',
        'email',
        'country_id',
        'city',
        'address',
        'class_of_account_id',
        'show_user',
        'maintain_account',
        'doc_name_1',
        'doc_file_1',
        'doc_expiry_1',
        'doc_name_2',
        'doc_file_2',
        'doc_expiry_2',
        'doc_name_3',
        'doc_file_3',
        'doc_expiry_3',
        'doc_name_4',
        'doc_file_4',
        'doc_expiry_4',
        'doc_name_5',
        'doc_file_5',
        'doc_expiry_5',
        'doc_name_6',
        'doc_file_6',
        'doc_expiry_6',
        'doc_name_7',
        'doc_file_7',
        'doc_expiry_7',
        'authorised_sign_1_name',
        'authorised_sign_1_civil_id',
        'authorised_sign_1_expiry_date',
        'authorised_sign_1_sign_sample',
        'authorised_sign_1_phone',
        'authorised_sign_2_name',
        'authorised_sign_2_civil_id',
        'authorised_sign_2_expiry_date',
        'authorised_sign_2_sign_sample',
        'authorised_sign_2_phone',
        'authorised_sign_3_name',
        'authorised_sign_3_civil_id',
        'authorised_sign_3_expiry_date',
        'authorised_sign_3_sign_sample',
        'authorised_sign_3_phone',
        'description',
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];

    // ACCESSOR
    // protected function image(): Attribute
    // {
    //     return Attribute::make(
    //         fn ($value) => !empty($value)?asset($value):asset('assets/profile_pics/admin.jpg'),
    //     );
    // }
}
