<?php

namespace App\Http\Controllers\MainMenu;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Country;
use App\ItemName;
use App\Location;
use App\PurchaseInvoice;
use App\PurchaseInvoiceItem;
use App\PurchaseSalesTransferStockTrack;
use App\Services\Utils;
use Auth;

class StockSearchController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    public function search()
    {
        $user = Auth::user();
        if (!$user->can('stock-search-permissions')) {
            abort(403, 'Unauthorized action.');
        }

        $countries = Country::all();
        return view('user.main_menu.stock_search', compact('countries'));
    }

    public function search_result(Request $request)
    {
        $user = Auth::user();
        if (!$user->can('stock-search-permissions')) {
            abort(403, 'Unauthorized action.');
        }

        $item_name = ItemName::Where('name', 'LIKE', '%' . $request->search . '%')->first();
        // $location = Location::Where('id', $item_name->location_id);
        $location = [];
        if ($item_name) {
            // $purchase_invoice_items = PurchaseInvoiceItem::Where('item_name_id', $item_name->id)->get();
            // foreach ($purchase_invoice_items as $item) {
            //     $purchase_invoice = PurchaseInvoice::Where('id', $item->purchase_invoice_id)->pluck('location_id');
            //     $location[] = Location::Where('id', $purchase_invoice)->first();
            // }
            $items = PurchaseSalesTransferStockTrack::with('location')->Where('item_name_id', $item_name->id)->get();
            // $location = [];
        }
        else{
            return redirect()->back()->withErrors("Stock Not Found");

        }


        return view('user.main_menu.stock_search_result', compact('item_name', 'items'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
