<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\AdminSalesInvoice;
use App\AdminPurchaesInvoice;
use Carbon\Carbon;
use App\Branches;
use App\AdminItemGroup;
use App\ItemName;
use App\Customer;
use App\debitNote;
use App\creditNote;
use App\OpeningBalance;
use App\PurchaseInvoiceExpense;
use App\AdminSalesInvoiceExpense;
use App\AdminPaymentVoucher;
use App\PaymentVoucherExpense;
use App\Supplier;
use App\StaffAndSalesman;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\Company;
use App\DeliveryNote;
use App\PurchaseOrder;
use App\Quotation;
use App\ClassOfAccount;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use PDF;
use Auth;
use App\WarehouseTransfer;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;
use App\Services\StockReportService;

class ProfitLossReportController extends Controller
{
    protected $stockReportService;

    public function __construct(StockReportService $stockReportService) {
        $this->stockReportService = $stockReportService;
    }

    public function view()
    {
        return view('crusher.reports.profit_loss_report');
    }
    public function groupStockSelect()
    {
        return view('crusher.partial_view.select-group');
    }
    public function profitLossReports(Request $request)
    {
        $lastFromDate = date("2003-01-01");
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

         // complete stock Opening & Closing Balance

         list($groupedItems, $groups, $from_date, $to_date,$allClosingStock,$allOpeningStock) = $this->stockReportService->completeStockReportClosingBalanceAndOpeningBalance($request, $request->from_date, $request->to_date);

            //  dd($allOpeningStock);

             // dd($combinedData,$groupedItems);
        $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $purchaseInvoiceExpenses = PurchaseInvoiceExpense::whereIn('admin_purchase_invoice_id', $purchaseInvoices->pluck('id'))
            ->get();

        $mergedPurchaseExpenses = $purchaseInvoiceExpenses
            ->groupBy('admin_purchase_invoice_id')
            ->map(function ($group) {
                return [
                    'account_name' => $group->first()->account_name,
                    'total_expense_amount' => $group->sum('expense_amount'),
                ];
            })
            ->values();

        $SalesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();
        $salesInvoiceExpenses = AdminSalesInvoiceExpense::whereIn('admin_sales_invoice_id', $SalesInvoices->pluck('id'))
                ->get();

        $mergedSalesExpenses = $salesInvoiceExpenses
            ->groupBy('admin_sales_invoice_id')
            ->map(function ($group) {
                return [
                    'account_name' => $group->first()->account_name,
                    'total_expense_amount' => $group->sum('expense_amount'),
                ];
            })
            ->values();

        $PaymentInvoices = AdminPaymentVoucher::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();
        $paymentInvoiceExpenses = PaymentVoucherExpense::whereIn('voucher_id', $PaymentInvoices->pluck('id'))
                ->get();

        $mergedPaymentExpenses = $paymentInvoiceExpenses
            ->groupBy('voucher_id')
            ->map(function ($group) {
                return [
                    'account_name' => $group->first()->account_name,
                    'amount' => $group->sum('amount'),
                ];
            })
            ->values();

        $classOfAccount = ClassOfAccount::all();

        $allAccounts = collect();

        $customers = Customer::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $staffAndSalesmen = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $expenses = Expense::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();
        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->with('classOfAccount')->get();

        $allAccounts = $allAccounts->merge($customers)->merge($staffAndSalesmen)->merge($suppliers)->merge($expenses)->merge($adminOtherAccounts);

        $totalDebit = [];
        $totalCredit = [];
        $processedAccounts = [];
        $mergedAccounts = [];
        foreach ($allAccounts as $account) {
        $PurchaesInvoice = AdminPurchaesInvoice::where('account_id', $account->id)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $SaleInvoice = AdminSalesInvoice::where('account_id', $account->id)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $ReceiptVoucher = ReceiptVoucherExpense::where('account_id', $account->id)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $PaymentVoucher = PaymentVoucherExpense::where('account_id', $account->id)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $CreditNote = CreditNote::where('account_id', $account->id)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $DebitNote = DebitNote::where('account_id', $account->id)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $TotalPurchaesInvoice = $PurchaesInvoice->sum('total_net_amount');
        $TotalDebitNote = $DebitNote->sum('total_net_amount');
        $TotalPaymentVoucher = $PaymentVoucher->sum('amount');

        $TotalSaleInvoice = $SaleInvoice->sum('total_net_amount');
        $TotalReceiptVoucher = $ReceiptVoucher->sum('amount');
        $TotalCreditNote = $CreditNote->sum('total_net_amount');

        $totalDebitAmount = ($TotalSaleInvoice + $TotalPaymentVoucher) + $TotalDebitNote;
        $totalCreditAmount = ($TotalPurchaesInvoice + $TotalCreditNote) + $TotalReceiptVoucher;

            if (!isset($mergedAccounts[$account->class_of_account_id])) {
                $mergedAccounts[$account->class_of_account_id] = [
                    'name' => optional($account->classOfAccount)->name,
                    'totalDebit' => 0,
                    'totalCredit' => 0,
                ];
            }

            $mergedAccounts[$account->class_of_account_id]['totalDebit'] += $totalDebitAmount;
            $mergedAccounts[$account->class_of_account_id]['totalCredit'] += $totalCreditAmount;
        }

        $mergedAccounts = array_filter($mergedAccounts, function ($data) {
            return $data['totalDebit'] > 0 || $data['totalCredit'] > 0;
        });

        // foreach ($mergedAccounts as $accountId => $data) {
        //     if ($data['name'] == 'Expenses') {
        //         $name = $data['name'];
        //         $totalDebit = $data['totalDebit'];
        //         $totalCredit = $data['totalCredit'];
        //     }
        // }

        // dd($mergedPurchaseExpenses,$mergedSalesExpenses,$mergedPaymentExpenses,$mergedAccounts);


        // All Purchaes Invoice Totals

        $AllPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');
        $AllDebitNoteInvoice = DebitNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllPurchaesTotals = $AllPurchaesInvoice - $AllDebitNoteInvoice;

        // All Sales Invoice Totals

        $AllSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllCreditNoteInvoice = CreditNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllSaleTotals = $AllSaleInvoice - $AllCreditNoteInvoice;

                $groups = AdminItemGroup::where('branch_id', session()->get('selected_branch'))->get();

                $itemNames = ItemName::with('unit')->where('branch_id', session()->get('selected_branch'))->get();

                $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->whereNotNull('invoice_no')
                    ->get();

                $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->whereNotNull('invoice_no')
                    ->get();


                $salesInvoice = AdminSalesInvoice::with([
                        'customer' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'supplier' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'StaffAndSalesman' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'Expense' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'AdminOtherAccount' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'item' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'item.group' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        }
                    ])
                    ->where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->orderBy('invoice_no')
                    ->get();

                    $originalPurchaseInvoice = AdminPurchaesInvoice::with([
                        'customer' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'supplier' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'StaffAndSalesman' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'Expense' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'AdminOtherAccount' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'item' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'item.group' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        }
                    ])
                    ->where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->whereNotNull('invoice_no')
                    ->orderBy('invoice_no')
                    ->get();

                $openingBalanceForInventory = OpeningBalance::with([
                        'customer' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'supplier' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'StaffAndSalesman' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'Expense' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'AdminOtherAccount' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'item' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        },
                        'item.group' => function ($query) {
                            $query->where('branch_id', session()->get('selected_branch'));
                        }
                    ])
                    ->where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->whereNotNull('invoice_no')
                    // ->groupBy('invoice_no')
                    ->orderBy('invoice_no')
                    ->get();
                $obSalesInvoice = AdminSalesInvoice::with([
                    'customer' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'supplier' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'StaffAndSalesman' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'Expense' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'AdminOtherAccount' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    }
                    ])
                    ->where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    // ->groupBy('invoice_no')
                    ->orderBy('invoice_no')
                    ->get();
                 $obPurchaseInvoice = AdminPurchaesInvoice::with([
                    'customer' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'supplier' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'StaffAndSalesman' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'Expense' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'AdminOtherAccount' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    }
                    ])
                    ->where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNotNull('invoice_no')
                    ->orderBy('invoice_no')
                    ->get();
                $cbSalesInvoice = AdminSalesInvoice::with([
                    'customer' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'supplier' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'StaffAndSalesman' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'Expense' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'AdminOtherAccount' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    }
                    ])
                    ->where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $from_date . ' 23:59:59')
                    // ->groupBy('invoice_no')
                    ->orderBy('invoice_no')
                    ->get();
                 $cbPurchaseInvoice = AdminPurchaesInvoice::with([
                    'customer' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'supplier' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'StaffAndSalesman' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'Expense' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    },
                    'AdminOtherAccount' => function ($query) {
                        $query->where('branch_id', session()->get('selected_branch'));
                    }
                    ])
                    ->where('branch_id', session()->get('selected_branch'))
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNotNull('invoice_no')
                    ->orderBy('invoice_no')
                    ->get();

                $salesInvoice = $salesInvoice->toArray();
                $openingBalanceForInventory = $openingBalanceForInventory->toArray();
                $originalPurchaseInvoice = $originalPurchaseInvoice->toArray();

                $obSalesInvoice = $obSalesInvoice->toArray();
                $obPurchaseInvoice = $obPurchaseInvoice->toArray();

                $cbSalesInvoice = $cbSalesInvoice->toArray();
                $cbPurchaseInvoice = $cbPurchaseInvoice->toArray();

                $profits = [];
                $remainingPurchaseQty = [];
                $remainingPurchaseRate = [];
                $obRemainingPurchaseQty = [];
                $obRemainingPurchaseRate = [];
                $cbRemainingPurchaseQty = [];
                $cbRemainingPurchaseRate = [];

                $cbPurchaseInvoices = $cbPurchaseInvoice;

                foreach ($cbSalesInvoice as $key => &$sale) {
                    $qtyToSell = $sale['quantity'];
                    $rate = $sale['rate_unit'];
                    $profit = 0;

                    foreach ($cbPurchaseInvoices as $purchaseKey => &$purchase) {
                        $purchaseQty = $purchase['quantity'];

                        if ($qtyToSell > 0 && $purchaseQty > 0) {
                            $unitsSold = min($qtyToSell, $purchaseQty);

                            $profit += $unitsSold * ($rate - $purchase['rate_unit']);

                            $cbPurchaseInvoices[$purchaseKey]['quantity'] -= $unitsSold;

                            $qtyToSell -= $unitsSold;
                        }
                    }

                    unset($purchase);

                    $profits[$sale['id']] = $profit;
                    $sale['profit'] = $profit;

                }
                $obPurchaseInvoices = $obPurchaseInvoice;

                foreach ($obSalesInvoice as $key => &$sale) {
                    $qtyToSell = $sale['quantity'];
                    $rate = $sale['rate_unit'];
                    $profit = 0;

                    foreach ($obPurchaseInvoices as $purchaseKey => &$purchase) {
                        $purchaseQty = $purchase['quantity'];

                        if ($qtyToSell > 0 && $purchaseQty > 0) {
                            $unitsSold = min($qtyToSell, $purchaseQty);

                            $profit += $unitsSold * ($rate - $purchase['rate_unit']);

                            $obPurchaseInvoices[$purchaseKey]['quantity'] -= $unitsSold;

                            $qtyToSell -= $unitsSold;
                        }
                    }

                    unset($purchase);

                    $profits[$sale['id']] = $profit;
                    $sale['profit'] = $profit;

                }

                $purchaseInvoice = array_merge($openingBalanceForInventory, $originalPurchaseInvoice);

                foreach ($salesInvoice as $key => &$sale) {
                    $qtyToSell = $sale['quantity'];
                    $rate = $sale['rate_unit'];
                    $profit = 0;

                    foreach ($purchaseInvoice as $purchaseKey => &$purchase) {
                        $purchaseQty = $purchase['quantity'];

                        if ($qtyToSell > 0 && $purchaseQty > 0) {
                            $unitsSold = min($qtyToSell, $purchaseQty);

                            $profit += $unitsSold * ($rate - $purchase['rate_unit']);

                            $purchaseInvoice[$purchaseKey]['quantity'] -= $unitsSold;

                            $qtyToSell -= $unitsSold;
                        }
                    }

                    unset($purchase);

                    $profits[$sale['id']] = $profit;
                    $sale['profit'] = $profit;

                }

                foreach ($purchaseInvoice as $purchaseKey => $remainingPurchase) {
                    $remainingPurchaseQty[$purchaseInvoice[$purchaseKey]['id']] = $remainingPurchase['quantity'];
                    $remainingPurchaseRate[$purchaseInvoice[$purchaseKey]['id']] = $remainingPurchase['quantity'] * $remainingPurchase['rate_unit'];

                }

                foreach ($obPurchaseInvoices as $purchaseKey => $remainingPurchase) {
                    $obRemainingPurchaseQty[$obPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'];
                    $obRemainingPurchaseRate[$obPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'] * $remainingPurchase['rate_unit'];
                }

                foreach ($cbPurchaseInvoices as $purchaseKey => $remainingPurchase) {
                    $cbRemainingPurchaseQty[$cbPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'];
                    $cbRemainingPurchaseRate[$cbPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'] * $remainingPurchase['rate_unit'];
                }

                $totalRemainingPurchaseQty = array_sum($remainingPurchaseQty);
                $totalRemainingPurchaseRate = array_sum($remainingPurchaseRate);
                $totalObRemainingPurchaseQty = array_sum($obRemainingPurchaseQty);
                $totalObRemainingPurchaseRate = array_sum($obRemainingPurchaseRate);
                $totalcbRemainingPurchaseQty = array_sum($cbRemainingPurchaseQty);
                $totalcbRemainingPurchaseRate = array_sum($cbRemainingPurchaseRate);

                $concatenatedData = array_merge($openingBalanceForInventory, $originalPurchaseInvoice, $salesInvoice);

                // dd($concatenatedData);
                // Discount

                $discountcustomer = Customer::where('branch_id', session()->get('selected_branch'))->get()->toArray();
                $discountstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->get()->toArray();
                $discountsupplier = Supplier::where('branch_id', session()->get('selected_branch'))->get()->toArray();
                $discountexpense = Expense::where('branch_id', session()->get('selected_branch'))->get()->toArray();
                $discountadminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->get()->toArray();

                $discountallAccounts = array_merge($discountcustomer, $discountstaffAndSalesman, $discountsupplier, $discountexpense, $discountadminOtherAccount);

                $discountPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->get()
                    ->toArray();

                $discountSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->get()
                    ->toArray();

                $discountQuotation = Quotation::with('expense')->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->groupBy('quotation_no')
                    ->get()
                    ->toArray();
                $discountObPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->toArray();

                $discountObSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->groupBy('invoice_no')
                    ->get()
                    ->toArray();

                $discountObQuotation = Quotation::with('expense')->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->groupBy('quotation_no')
                    ->get()
                    ->toArray();

                $discountpurchaesInvoiceData = [];
                $discountsaleInvoiceData = [];
                $discountQuotationData = [];

                $discountObpurchaesInvoiceData = [];
                $discountObsaleInvoiceData = [];
                $discountObQuotationData = [];

                foreach ($discountallAccounts as $account) {
                    $accountId = $account['id'];

                    $purchaseInvoiceMatch = array_filter($discountPurchaesInvoice, function ($invoice) use ($accountId) {
                        return $invoice['account_id'] == $accountId;
                    });

                    $saleInvoiceMatch = array_filter($discountSaleInvoice, function ($invoice) use ($accountId) {
                        return $invoice['account_id'] == $accountId;
                    });

                    $QuotationMatch = array_filter($discountQuotation, function ($invoice) use ($accountId) {
                        return $invoice['account_id'] == $accountId;
                    });

                    if (!empty($purchaseInvoiceMatch)) {
                        $discountpurchaesInvoiceData[$accountId] = $purchaseInvoiceMatch;
                    }

                    if (!empty($saleInvoiceMatch)) {
                        $discountsaleInvoiceData[$accountId] = $saleInvoiceMatch;
                    }

                    if (!empty($QuotationMatch)) {
                        $discountQuotationData[$accountId] = $QuotationMatch;
                    }
                }

                foreach ($discountallAccounts as $account) {
                    $accountId = $account['id'];

                    $ObpurchaseInvoiceMatch = array_filter($discountObPurchaesInvoice, function ($invoice) use ($accountId) {
                        return $invoice['account_id'] == $accountId;
                    });

                    $ObsaleInvoiceMatch = array_filter($discountObSaleInvoice, function ($invoice) use ($accountId) {
                        return $invoice['account_id'] == $accountId;
                    });

                    $ObQuotationMatch = array_filter($discountObQuotation, function ($invoice) use ($accountId) {
                        return $invoice['account_id'] == $accountId;
                    });

                    if (!empty($ObpurchaseInvoiceMatch)) {
                        $discountObpurchaesInvoiceData[$accountId] = $ObpurchaseInvoiceMatch;
                    }

                    if (!empty($ObsaleInvoiceMatch)) {
                        $discountObsaleInvoiceData[$accountId] = $ObsaleInvoiceMatch;
                    }

                    if (!empty($ObQuotationMatch)) {
                        $discountObQuotationData[$accountId] = $ObQuotationMatch;
                    }
                }


        return view('crusher.reports.profits-and-loss-report', compact('from_date', 'to_date', 'AllPurchaesInvoice','AllSaleInvoice','salesInvoice','openingBalanceForInventory','originalPurchaseInvoice','concatenatedData','profits','totalRemainingPurchaseQty','totalRemainingPurchaseRate','totalObRemainingPurchaseQty','totalObRemainingPurchaseRate','totalcbRemainingPurchaseQty','totalcbRemainingPurchaseRate','mergedPurchaseExpenses','mergedSalesExpenses','mergedPaymentExpenses','mergedAccounts','discountallAccounts', 'discountsaleInvoiceData','discountpurchaesInvoiceData','discountQuotationData','discountObsaleInvoiceData','discountObpurchaesInvoiceData','discountObQuotationData','AllPurchaesTotals','AllSaleTotals','allClosingStock','allOpeningStock'));
    }

    public function groupStockPL(Request $request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $groups = AdminItemGroup::where('branch_id', session()->get('selected_branch'))->get();

        $itemNames = ItemName::with('unit')->where('branch_id', session()->get('selected_branch'))->get();

        $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
        ->whereIn('item_id', $itemNames->pluck('id'))
        ->whereNotNull('invoice_no')
        ->get();

        $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('item_id', $itemNames->pluck('id'))
            ->whereNotNull('invoice_no')
            ->get();


        $salesInvoice = AdminSalesInvoice::with([
                'customer' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'supplier' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'StaffAndSalesman' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'Expense' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'AdminOtherAccount' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'item' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'item.group' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                }
            ])
            ->where('branch_id', session()->get('selected_branch'))
            ->whereIn('item_id', $itemNames->pluck('id'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            // ->groupBy('invoice_no')
            ->orderBy('invoice_no')
            ->get();

            $originalPurchaseInvoice = AdminPurchaesInvoice::with([
                'customer' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'supplier' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'StaffAndSalesman' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'Expense' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'AdminOtherAccount' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'item' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'item.group' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                }
            ])
            ->where('branch_id', session()->get('selected_branch'))
            ->whereIn('item_id', $itemNames->pluck('id'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNotNull('invoice_no')
            ->orderBy('invoice_no')
            ->get();

        $openingBalanceForInventory = OpeningBalance::with([
                'customer' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'supplier' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'StaffAndSalesman' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'Expense' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'AdminOtherAccount' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'item' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                },
                'item.group' => function ($query) {
                    $query->where('branch_id', session()->get('selected_branch'));
                }
            ])
            ->where('branch_id', session()->get('selected_branch'))
            ->whereIn('item_id', $itemNames->pluck('id'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNotNull('invoice_no')
            // ->groupBy('invoice_no')
            ->orderBy('invoice_no')
            ->get();
        $obSalesInvoice = AdminSalesInvoice::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'StaffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'Expense' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'AdminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
        ->where('branch_id', session()->get('selected_branch'))
        ->whereIn('item_id', $itemNames->pluck('id'))
        ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
        ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
        // ->groupBy('invoice_no')
        ->orderBy('invoice_no')
        ->get();
         $obPurchaseInvoice = AdminPurchaesInvoice::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'StaffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'Expense' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'AdminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
         ->where('branch_id', session()->get('selected_branch'))
         ->whereIn('item_id', $itemNames->pluck('id'))
         ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
         ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
         ->whereNotNull('invoice_no')
         ->orderBy('invoice_no')
         ->get();
        $cbSalesInvoice = AdminSalesInvoice::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'StaffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'Expense' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'AdminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
        ->where('branch_id', session()->get('selected_branch'))
        ->whereIn('item_id', $itemNames->pluck('id'))
        ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
        ->where('date', '<=', $from_date . ' 23:59:59')
        // ->groupBy('invoice_no')
        ->orderBy('invoice_no')
        ->get();
         $cbPurchaseInvoice = AdminPurchaesInvoice::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'StaffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'Expense' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'AdminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
         ->where('branch_id', session()->get('selected_branch'))
         ->whereIn('item_id', $itemNames->pluck('id'))
         ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
         ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
         ->whereNotNull('invoice_no')
         ->orderBy('invoice_no')
         ->get();

        $salesInvoice = $salesInvoice->toArray();
        $openingBalanceForInventory = $openingBalanceForInventory->toArray();
        $originalPurchaseInvoice = $originalPurchaseInvoice->toArray();

        $obSalesInvoice = $obSalesInvoice->toArray();
        $obPurchaseInvoice = $obPurchaseInvoice->toArray();

        $cbSalesInvoice = $cbSalesInvoice->toArray();
        $cbPurchaseInvoice = $cbPurchaseInvoice->toArray();

        $profits = [];
        $remainingPurchaseQty = [];
        $remainingPurchaseRate = [];
        $obRemainingPurchaseQty = [];
        $obRemainingPurchaseRate = [];
        $cbRemainingPurchaseQty = [];
        $cbRemainingPurchaseRate = [];

        $cbPurchaseInvoices = $cbPurchaseInvoice;

        foreach ($cbSalesInvoice as $key => &$sale) {
            $qtyToSell = $sale['quantity'];
            $rate = $sale['rate_unit'];
            $profit = 0;

            foreach ($cbPurchaseInvoices as $purchaseKey => &$purchase) {
                $purchaseQty = $purchase['quantity'];

                if ($qtyToSell > 0 && $purchaseQty > 0) {
                    $unitsSold = min($qtyToSell, $purchaseQty);

                    $profit += $unitsSold * ($rate - $purchase['rate_unit']);

                    $cbPurchaseInvoices[$purchaseKey]['quantity'] -= $unitsSold;

                    $qtyToSell -= $unitsSold;
                }
            }

            unset($purchase);

            $profits[$sale['id']] = $profit;
            $sale['profit'] = $profit;

        }
        $obPurchaseInvoices = $obPurchaseInvoice;

        foreach ($obSalesInvoice as $key => &$sale) {
            $qtyToSell = $sale['quantity'];
            $rate = $sale['rate_unit'];
            $profit = 0;

            foreach ($obPurchaseInvoices as $purchaseKey => &$purchase) {
                $purchaseQty = $purchase['quantity'];

                if ($qtyToSell > 0 && $purchaseQty > 0) {
                    $unitsSold = min($qtyToSell, $purchaseQty);

                    $profit += $unitsSold * ($rate - $purchase['rate_unit']);

                    $obPurchaseInvoices[$purchaseKey]['quantity'] -= $unitsSold;

                    $qtyToSell -= $unitsSold;
                }
            }

            unset($purchase);

            $profits[$sale['id']] = $profit;
            $sale['profit'] = $profit;

        }

        // $purchaseInvoice = $openingBalanceForInventory + $originalPurchaseInvoice;
        $purchaseInvoice = array_merge($openingBalanceForInventory, $originalPurchaseInvoice);

        foreach ($salesInvoice as $key => &$sale) {
            $qtyToSell = $sale['quantity'];
            $rate = $sale['rate_unit'];
            $profit = 0;

            foreach ($purchaseInvoice as $purchaseKey => &$purchase) {
                $purchaseQty = $purchase['quantity'];

                if ($qtyToSell > 0 && $purchaseQty > 0) {
                    $unitsSold = min($qtyToSell, $purchaseQty);

                    $profit += $unitsSold * ($rate - $purchase['rate_unit']);

                    $purchaseInvoice[$purchaseKey]['quantity'] -= $unitsSold;

                    $qtyToSell -= $unitsSold;
                }
            }

            unset($purchase);

            $profits[$sale['id']] = $profit;
            $sale['profit'] = $profit;

        }

        foreach ($purchaseInvoice as $purchaseKey => $remainingPurchase) {
            $remainingPurchaseQty[$purchaseInvoice[$purchaseKey]['id']] = $remainingPurchase['quantity'];
            $remainingPurchaseRate[$purchaseInvoice[$purchaseKey]['id']] = $remainingPurchase['quantity'] * $remainingPurchase['rate_unit'];

        }

        foreach ($obPurchaseInvoices as $purchaseKey => $remainingPurchase) {
            $obRemainingPurchaseQty[$obPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'];
            $obRemainingPurchaseRate[$obPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'] * $remainingPurchase['rate_unit'];
        }

        foreach ($cbPurchaseInvoices as $purchaseKey => $remainingPurchase) {
            $cbRemainingPurchaseQty[$cbPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'];
            $cbRemainingPurchaseRate[$cbPurchaseInvoices[$purchaseKey]['id']] = $remainingPurchase['quantity'] * $remainingPurchase['rate_unit'];
        }

        $totalRemainingPurchaseQty = array_sum($remainingPurchaseQty);
        $totalRemainingPurchaseRate = array_sum($remainingPurchaseRate);
        $totalObRemainingPurchaseQty = array_sum($obRemainingPurchaseQty);
        $totalObRemainingPurchaseRate = array_sum($obRemainingPurchaseRate);
        $totalcbRemainingPurchaseQty = array_sum($cbRemainingPurchaseQty);
        $totalcbRemainingPurchaseRate = array_sum($cbRemainingPurchaseRate);

        $concatenatedData = array_merge($openingBalanceForInventory, $originalPurchaseInvoice, $salesInvoice);

        // dd($openingBalanceForInventory,$originalPurchaseInvoice,$salesInvoice);

        return view('crusher.partial_view.group-stock', compact('salesInvoice','openingBalanceForInventory','originalPurchaseInvoice', 'from_date', 'to_date', 'concatenatedData','profits','totalRemainingPurchaseQty','totalRemainingPurchaseRate','totalObRemainingPurchaseQty','totalObRemainingPurchaseRate','totalcbRemainingPurchaseQty','totalcbRemainingPurchaseRate'));
    }
}
