@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Approval Voucher do Report</h6>
                        </div>
                        {{-- <div class="col-md-6">
                            <a href="{{ route('crusher.delivery_notes.create') }} ">
                                <button class="btn btn-cust1 float-right" type="submit">Create Delivery Note
                                </button>
                            </a>
                        </div> --}}
                    </div>
                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="datatable" class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Delivery Note Number</th>
                                    <th>Quotation Number</th>
                                    <th>Account Name</th>
                                    <th>Invoice Number</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @forelse ($deliveryNotes as $deliveryNote)
                                    {{-- @dd($deliveryNote)     --}}
                                    <tr>
                                        <td>{{ $deliveryNote->date }}</td>
                                        <td>{{ $deliveryNote->do_no }}</td>
                                        <td>{{ $deliveryNote->quotation_no }}</td>
                                        <td>
                                            @if ($deliveryNote->account_type == 'App\Customer' || $deliveryNote->account_type == 'App\Supplier')
                                                {{ $deliveryNote->account_type::find($deliveryNote->account_id)->name_of_organisation }}
                                            @elseif ($deliveryNote->account_type == 'App\StaffAndSalesman')
                                                {{ $deliveryNote->account_type::find($deliveryNote->account_id)->first_name.' '.$deliveryNote->account_type::find($deliveryNote->account_id)->last_name }}
                                            @else
                                                {{ $deliveryNote->account_type::find($deliveryNote->account_id)->account_name }}
                                            @endIf
                                        </td>
                                        <td>{{ $deliveryNote->salesInvoice->invoice_no??'' }}</td>
                                        <td>
                                            <a
                                                href="{{ route('crusher.delivery_notes.show', ['delivery_note' => $deliveryNote->id]) }}">
                                                <i class="far fa-eye cust-icon2"></i>
                                            </a>
                                        </td>
                                    </tr>
                                @empty
                                @endforelse
                            </tbody>
                        </table>
                    </div>

                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
@endsection
