@extends('layouts.master_user')
@section('page-title')
Expense Master
@endsection
@section('css')
<style>
    .top {
        margin-top: 22px;
    }
</style>

@endsection
@section('master')
active
@endsection
@section('account_master')
active
@endsection
@section('expenses')
active
@endsection
@section('content')
{{--
    @section('page-breadcrumb')
<li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Expense Master</strong>
</li>
@endsection
--}}

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="row wrapper white-bg page-heading">
        <div class="col-md-12">
            <a href="/masters/account-masters/expenses/create" class="btn btn-primary pull-right"><i class="fa fa-plus" aria-hidden="true"></i> Create Expense</a>
        </div>
        @if(count($expenses) != 0)
        <div class="col-md-12">
            <div class="card strpied-tabled-with-hover" style="padding-top: 20px;">
                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered table-hover dt-responsive" >
                        <thead>
                        <tr>
                            {{-- <th>Account ID</th> --}}
                            <th>Account Name</th>
                            <th>Passwords</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                            @foreach($expenses as $key => $expense)
                            <tr>
                                {{-- <td>{{ $expenses[$key]->account_id }}</td> --}}
                                <td>{{ $expenses[$key]->account_name }}</td>
                                <td>
                                    @if ($expenses[$key]->transactions_password != "")
                                        <p>T Password</p>
                                    @endif
                                    @if ($expenses[$key]->report_password != "")
                                        <p>R Password</p>
                                    @endif
                                </td>
                                <td>
                                    {{-- @if ($expenses[$key]->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Deleted</button>
                                    @else --}}
                                        <div class="btn-group">
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/masters/account-masters/expenses/{{ $expenses[$key]->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @if ($count[$key] < 1)
                                            <div class="pull-right">
                                                <form  method="post" action="/masters/account-masters/expenses/{{ $expenses[$key]->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                                </form>
                                            </div>
                                            @else
                                                <button type="button" disabled class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                            @endif
                                        </div>
                                    {{-- @endif     --}}
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        @if ($expenses->hasPages())
                        <tfoot>
                            <tr>
                                <td colspan="6" class="footable-visible text-center">
                                    {!! $expenses->links() !!}
                                </td>
                            </tr>
                        </tfoot>
                        @endif
                        </table>
                    </div>
                </div>
            </div>
        </div>
        @else
            <h4 style="text-align:center;">No expense has been created yet.</h4>
        @endif
    </div>
</div>
@endsection

@section('js')
<script>
    $(document).ready(function(){
        $('.dataTables-expenses').DataTable({
            pageLength: 25,
            dom: '<"html5buttons"B>lTfgitp',
            buttons: [
                { extend: 'copy'},
                {extend: 'csv'},
                {extend: 'excel', title: 'ExampleFile'},
                {extend: 'pdf', title: 'ExampleFile'},

                {extend: 'print',
                 customize: function (win){
                        $(win.document.body).addClass('white-bg');
                        $(win.document.body).css('font-size', '10px');

                        $(win.document.body).find('table')
                                .addClass('compact')
                                .css('font-size', 'inherit');
                }
                }
            ]

        });

    });

</script>
@endsection
