<!doctype html>
<html>
<head>
    <meta charset="utf-8">
    <title>Invoice</title>

    <style>
    .invoice-box {
        max-width: 800px;
        margin: auto;
        padding: 30px;
        border: 1px solid #eee;
        box-shadow: 0 0 10px rgba(0, 0, 0, .15);
        font-size: 16px;
        line-height: 24px;
        font-family: 'Helvetica Neue', 'Helvetica', Helvetica, Arial, sans-serif;
        color: #555;
    }

    .invoice-box table {
        width: 100%;
        line-height: inherit;
        text-align: left;
    }

    .invoice-box table td {
        padding: 5px;
        vertical-align: top;
    }
/*
    .invoice-box table tr td:nth-child(2) {
        text-align: right;
    } */

    /* .invoice-box table tr td:nth-child(3) {
        text-align: right;
    } */

    .invoice-box table tr.top table td:nth-child(2) {
        text-align: right;
    }

    .invoice-box table tr.top table td {
        padding-bottom: 20px;
    }

    .invoice-box table tr.top table td.title {
        font-size: 45px;
        line-height: 45px;
        color: #333;
    }

    .invoice-box table tr.information table td:nth-child(2) {
        text-align: right;
    }

    .invoice-box table tr.information table td {
        padding-bottom: 40px;
    }

    .invoice-box table tr.heading td {
        background: #eee;
        border-bottom: 1px solid #ddd;
        font-weight: bold;
    }

    .invoice-box table tr.details td {
        padding-bottom: 20px;
    }

    .invoice-box table tr.item td{
        border-bottom: 1px solid #eee;
    }

    .invoice-box table tr.item.last td {
        border-bottom: none;
    }

    .invoice-box table tr.total td:nth-child(3) {
        border-top: 2px solid #eee;
        font-weight: bold;
    }

    @media only screen and (max-width: 600px) {
        .invoice-box table tr.top table td {
            width: 100%;
            display: block;
            text-align: center;
        }

        .invoice-box table tr.information table td {
            width: 100%;
            display: block;
            text-align: center;
        }
    }

    /** RTL **/
    .rtl {
        direction: rtl;
        font-family: Tahoma, 'Helvetica Neue', 'Helvetica', Helvetica, Arial, sans-serif;
    }

    .rtl table {
        text-align: right;
    }

    .rtl table tr td:nth-child(2) {
        text-align: left;
    }
    </style>
</head>

<body>
    <div class="invoice-box">
        <table cellpadding="0" cellspacing="0">
            <tr class="top">
                <td colspan="8">
                    <table>
                        <tr>
                            <td class="title">
                                <img src="{{ url('') }}" style="width:100%; max-width:180px;">
                            </td>

                            <td>
                                Order #: <br>
                                Order Date:<br>
                                Delivery Date:
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>

            <tr class="information">
                <td colspan="8">
                    <table>
                        <tr>
                            <td>
                                <h3>From</h3>
                            </td>

                            <td>
                                <h3>To</h3>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>

            <tr class="heading">
                <td>

                    <div class="table-responsive m-t">
                        <table class="table table-bordered" >
                            <thead>
                            <tr>
                                <th class="col">Item Id</th>
                                <th class="col">Color</th>
                                <th class="col">Item Description</th>
                                <th class="col">IMEI/Serial/Other</th>
                                <th class="col">Quantity</th>
                                <th class="col">Rate/Quantity</th>
                                <th class="col">Amount</th>
                                <th class="col">Remarks</th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr>
                                <td>50</span></td>
                                <td><span>Gold White</span></td>
                                <td><span>Iphone 6s Gold White 32 GB</span></td>
                                <td>123456789</td>
                                <td>3</td>
                                <td>25000</td>
                                <td>75000</td>
                                <td>Thanks for shopping</td>
                            </tr>
                            <tr>
                                <td><span>50</span></td>
                                <td><span>Gold White</span></td>
                                <td><span>Iphone 6s Gold White 32 GB</span></td>
                                <td><span>123456789</span></td>
                                <td><span>3</span></td>
                                <td><span>25000</span></td>
                                <td><span>75000</span></td>
                                <td><span>Thanks for shopping</span></td>
                            </tr>
                             <tr>
                                <td><span>50</span></td>
                                <td><span>Gold White</span></td>
                                <td><span>Iphone 6s Gold White 32 GB</span></td>
                                <td><span>123456789</span></td>
                                <td><span>3</span></td>
                                <td><span>25000</span></td>
                                <td><span>75000</span></td>
                                <td><span>Thanks for shopping</span></td>
                             </tr>

                            </tbody>
                        </table>
                    </div>
                </td>
            <tr class="item">
                <td>
                    title
                </td>

                <td>
                    1
                </td>

                <td>
                   1000.00
                </td>
            </tr>

            <tr class="">
                <td  colspan="8">
                    Sub Total: Rs 1000.00
                </td>
            </tr>
            <tr class="">
                <td></td>

                <td></td>

                <td>
                    Shipping Cost: Rs 300
                </td>
            </tr>
            <tr class="total">
                <td></td>

                <td></td>

                <td>
                    Total: 13000.00
                </td>
            </tr>
        </table>
    </div>
</body>
</html>
