@extends('layouts.master_user')
@section('page-title')
Detail Balance Sheet
@endsection
@section('css')
<style>
    .top {
        margin-top: 22px;
    }
    td:nth-child(2){
        text-align: right;
    }
    td:nth-child(3){
        text-align: right;
    }
    td:nth-child(5){
        text-align: right;
    }
    td:nth-child(6){
        text-align: right;
    }
    th{
        text-align: center;
    }
</style>

@endsection
@section('reports')
active
@endsection
@section('balance-sheet')
active
@endsection
@section('content')
{{--
@section('page-breadcrumb')
<li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Customer Master</strong>
</li>
@endsection--}}

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">
        {{-- <div class="ibox-title">
            <h5>Add Customers</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
        </div> --}}
        <div class="ibox-content">
            <form method="get" class="form-horizontal">
                <div class="form-group">
                    <div class="row">
                        <div class="col-md-6">
                            <p><strong>Date : </strong><strong>{{\Carbon\Carbon::parse($from_date)->format('d-m-Y')}} to {{\Carbon\Carbon::parse($to_date)->format('d-m-Y')}}</strong></p>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <label for="select-view-type">Select View Type</label>
                        <select name="select_view_type" class="form-control" id="select_view_type_id" onchange="viewBalaneSheet()">
                            <option value="detail_view">Detail View</option>
                            <option value="condense_view">Condense View</option>
                        </select>
                    </div>
                </div>
            </form>
                <div class="row">
                    <div class="col-md-6">
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th colspan="3">Liabilities</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($reserve_and_surplus as $reserve)
                                    <tr class="detail_only">
                                        <td width="30%">{{$reserve['ledger']->name_of_organisation}}</td>
                                        <td width="10%">{{$reserve['closing_balance_decimal']}}</td>
                                        <td width="10%"><b></b></td>
                                    </tr>
                                @endforeach
                                <tr>
                                    <td width="30%"><b>Reserve And Surplus</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($reserve_and_surplus_total, $decimal, '.', '')}}</b></td>
                                </tr>

                                @foreach ($retained_earnings as $earning)
                                    <tr class="detail_only">
                                        <td width="30%">{{$earning['ledger']->name_of_organisation}}</td>
                                        <td width="10%">{{$earning['closing_balance_decimal']}}</td>
                                        <td width="10%"><b></b></td>
                                    </tr>
                                @endforeach
                                <tr>
                                    <td width="30%"><b>Retained Earnings</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($retained_earnings_total, $decimal, '.', '')}}</b></td>
                                </tr>
                                <tr>
                                    <td width="30%"><b>Capital Account</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($capital_account_total, $decimal, '.', '')}}</b></td>
                                </tr>


                                @foreach ($sundry_creditors as $credit)
                                @if ($credit['closing_balance_decimal'] > 0)
                                    <tr class="detail_only">
                                        <td width="30%">
                                            <form class="form-horizontal" method="POST" action="/reports/statement-of-accounts/ledger" enctype="multipart/form-data">
                                                @csrf
                                                <input type="hidden" id="from_date" name="from_date" class="form-control" value="{{ $from_date }}">
                                                <input type="hidden" id="to_date" name="to_date" class="form-control" value="{{ $to_date }}">
                                                <input type="hidden" id="ledger_account_class_name" name="ledger_account_class_name" class="form-control" value="ledger">
                                                <input type="hidden" id="ledger_class" name="ledger_class" class="form-control" value="{{$credit['ledger']->id}}">
                                                <button class="btn" style="background:transparent" type="submit">{{$credit['ledger']->name_of_organisation}}</button>
                                            </form>
                                            {{-- {{$credit['ledger']->name_of_organisation}}</td> --}}
                                        <td width="10%">{{$credit['closing_balance_decimal']}}</td>
                                        <td width="10%"><b></b></td>
                                    </tr>
                                @endif
                                @endforeach
                                <tr>
                                    <td width="30%"><b>Sundry Creditors</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($sundry_creditors_total, $decimal, '.', '')}}</b></td>
                                </tr>
                                <tr>
                                    <td width="30%"><b>VAT Payable/Receiveable</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($vat_payable_receiveable, $decimal, '.', '')}}</b></td>
                                </tr>
                                <tr>
                                    <td width="30%"><b>Current Liabilities</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($sundry_creditors_total, $decimal, '.', '')}}</b></td>
                                </tr>

                                {{-- <tr>
                                    <td width="30%"><b>Total</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($total, $decimal, '.', '')}}</b></td>
                                </tr> --}}


                            </tbody>
                        </table>
                    </div>
                    <div class="col-md-6">
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th colspan="3">Assets</th>
                                </tr>
                            </thead>
                            <tbody>

                                @foreach ($bank_account as $bank)
                                @if ($bank['closing_balance_decimal'] > 0)
                                    <tr class="detail_only">
                                        <td width="30%">
                                            <form class="form-horizontal" method="POST" action="/reports/statement-of-accounts/ledger" enctype="multipart/form-data">
                                                @csrf
                                                <input type="hidden" id="from_date" name="from_date" class="form-control" value="{{ $from_date }}">
                                                <input type="hidden" id="to_date" name="to_date" class="form-control" value="{{ $to_date }}">
                                                <input type="hidden" id="ledger_account_class_name" name="ledger_account_class_name" class="form-control" value="ledger">
                                                <input type="hidden" id="ledger_class" name="ledger_class" class="form-control" value="{{$bank['ledger']->id}}">
                                                <button class="btn" style="background:transparent" type="submit">{{$bank['ledger']->name_of_organisation}}</button>
                                            </form>
                                            {{-- {{$bank['ledger']->name_of_organisation}} --}}
                                        </td>
                                        <td width="10%">{{$bank['closing_balance_decimal']}}</td>
                                        <td width="10%"><b></b></td>
                                    </tr>
                                @endif
                                @endforeach
                                <tr>
                                    <td width="30%"><b>Bank Accounts</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($bank_account_total, $decimal, '.', '')}}</b></td>
                                </tr>

                                @foreach ($cash_in_hand as $cash)
                                @if ($cash['closing_balance_decimal'] > 0)
                                    <tr class="detail_only">
                                        <td width="30%">
                                            <form class="form-horizontal" method="POST" action="/reports/statement-of-accounts/ledger" enctype="multipart/form-data">
                                                @csrf
                                                <input type="hidden" id="from_date" name="from_date" class="form-control" value="{{ $from_date }}">
                                                <input type="hidden" id="to_date" name="to_date" class="form-control" value="{{ $to_date }}">
                                                <input type="hidden" id="ledger_account_class_name" name="ledger_account_class_name" class="form-control" value="ledger">
                                                <input type="hidden" id="ledger_class" name="ledger_class" class="form-control" value="{{$cash['ledger']->id}}">
                                                <button class="btn" style="background:transparent" type="submit">{{$cash['ledger']->name_of_organisation}}</button>
                                            </form>
                                            {{-- {{$cash['ledger']->name_of_organisation}} --}}
                                        </td>
                                        <td width="10%">{{$cash['closing_balance_decimal']}}</td>
                                        <td width="10%"><b></b></td>
                                    </tr>
                                @endif
                                @endforeach
                                <tr>
                                    <td width="30%"><b>Cash In Hands</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($cash_in_hand_total, $decimal, '.', '')}}</b></td>
                                </tr>

                                @foreach ($advance as $item)
                                @if ($item['closing_balance_decimal'] > 0)
                                <tr class="detail_only">
                                    <td width="30%">
                                        <form class="form-horizontal" method="POST" action="/reports/statement-of-accounts/ledger" enctype="multipart/form-data">
                                            @csrf
                                            <input type="hidden" id="from_date" name="from_date" class="form-control" value="{{ $from_date }}">
                                            <input type="hidden" id="to_date" name="to_date" class="form-control" value="{{ $to_date }}">
                                            <input type="hidden" id="ledger_account_class_name" name="ledger_account_class_name" class="form-control" value="ledger">
                                            <input type="hidden" id="ledger_class" name="ledger_class" class="form-control" value="{{$item['ledger']->id}}">
                                            <button class="btn" style="background:transparent" type="submit">{{$item['ledger']->name_of_organisation}}</button>
                                        </form>
                                        {{-- {{$item['ledger']->name_of_organisation}} --}}
                                    </td>
                                    <td width="10%">{{$item['closing_balance_decimal']}}</td>
                                    <td width="10%"><b></b></td>
                                </tr>
                                @endif
                                @endforeach
                                <tr>
                                    <td width="30%"><b>Advance</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($advance_total, $decimal, '.', '')}}</b></td>
                                </tr>

                                {{-- @foreach ($stock_in_hand as $stock)
                                <tr class="detail_only">
                                    <td width="30%">
                                        <form class="form-horizontal" method="POST" action="/reports/statement-of-accounts/ledger" enctype="multipart/form-data">
                                            @csrf
                                            <input type="hidden" id="from_date" name="from_date" class="form-control" value="{{ $from_date }}">
                                            <input type="hidden" id="to_date" name="to_date" class="form-control" value="{{ $to_date }}">
                                            <input type="hidden" id="ledger_account_class_name" name="ledger_account_class_name" class="form-control" value="ledger">
                                            <input type="hidden" id="ledger_class" name="ledger_class" class="form-control" value="{{$stock['ledger']->id}}">
                                            <button class="btn" style="background:transparent" type="submit">{{$stock['ledger']->name_of_organisation}}</button>
                                        </form>
                                    </td>
                                    <td width="10%">{{$stock['closing_balance_decimal']}}</td>
                                    <td width="10%"><b></b></td>
                                </tr>
                                @endforeach --}}
                                <tr>
                                    <td width="30%"><b>Closing Stock</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($stock_in_hand_total, $decimal, '.', '')}}</b></td>
                                </tr>

                                @foreach ($sundry_debtors as $debt)
                                @if ($debt['closing_balance_decimal'] > 0)
                                <tr class="detail_only">
                                    <td width="30%">
                                        <form class="form-horizontal" method="POST" action="/reports/statement-of-accounts/ledger" enctype="multipart/form-data">
                                            @csrf
                                            <input type="hidden" id="from_date" name="from_date" class="form-control" value="{{ $from_date }}">
                                            <input type="hidden" id="to_date" name="to_date" class="form-control" value="{{ $to_date }}">
                                            <input type="hidden" id="ledger_account_class_name" name="ledger_account_class_name" class="form-control" value="ledger">
                                            <input type="hidden" id="ledger_class" name="ledger_class" class="form-control" value="{{$debt['ledger']->id}}">
                                            <button class="btn" style="background:transparent" type="submit">{{$debt['ledger']->name_of_organisation}}</button>
                                        </form>
                                        {{-- {{$debt['ledger']->name_of_organisation}} --}}
                                    </td>
                                    <td width="10%">{{$debt['closing_balance_decimal']}}</td>
                                    <td width="10%"><b></b></td>
                                </tr>
                                @endif
                                @endforeach
                                <tr>
                                    <td width="30%"><b>Sundry Debtors</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($sundry_debtors_total, $decimal, '.', '')}}</b></td>
                                </tr>
                                <tr>
                                    <td width="30%"><b>Current Assets</b></td>
                                    <td width="10%"></td>
                                    <td width="10%"><b>{{number_format($current_assets, $decimal, '.', '')}}</b></td>
                                </tr>


                            </tbody>
                        </table>
                    </div>
                </div>

        </div>
    </div>
</div>
@endsection

@section('js')
<script>
    $('.detail_only').show();

    function viewBalaneSheet(){
        var select_type=$('#select_view_type_id').val();
        if(select_type=='detail_view'){
            $('.detail_only').show();
        }
        if(select_type=='condense_view'){
            $('.detail_only').hide();
        }
    }

    $(document).ready(function() {
        $('.input-group.date').datepicker({
            startView: 1,
            todayBtn: "linked",
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true,
            format: "dd/mm/yyyy"
        }).datepicker('setDate',new Date());
    });
</script>
@endsection
