
@extends('layouts.master_user')
@section('page-title')
Salesman Report
@endsection
@section('css')
<style>
    .display-none{
        display: none;
    }
</style>

@endsection
@section('reports')
active
@endsection
@section('salesman-report')
active
@endsection
@section('content')

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">
        {{-- <div class="ibox-title">
            <h5>Expense</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
        </div> --}}
        <div class="ibox-content">
            <form class="form-horizontal" method="POST" id="create_form" action="/reports/salesman-report" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                    <div class="col-sm-4">
                        <label for="select_type">Select SalesMan</label>
                        <select name="salesman_id" id="select_salesman" class="form-control" required>
                            <option value="">Select SalesMan</option>
                            @foreach ($salesmen as $salesman)
                                <option value="{{ $salesman->id }}">{{ $salesman-> first_name }} {{ $salesman-> last_name }}</option>
                            @endforeach
                        </select>
                        <input type="hidden" name="pass_check" id="pass_check" value="">
                    </div>
                </div>
                {{-- <div class="form-group">
                    <div class="col-sm-4">
                        <label for="select_type">Select Report Type</label>
                        <select name="report_type" id="report_type" class="form-control" onchange="showDate()">
                            <option value="">Select Report Type</option>
                            <option value="date_wise">Date Wise</option>
                            <option value="month_wise">Month Wise</option>
                        </select>
                    </div>
                </div> --}}
                {{-- <div class="form-group display-none" id="show_date"> --}}
                    <div class="form-group" id="">
                    <div class="col-sm-4">
                        <label>From Date </label>
                        <div class="input-group date">
                            <span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text"
                                name="from_date" class="form-control" value="" required>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <label>To Date </label>
                        <div class="input-group date">
                            <span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text"
                                name="to_date" class="form-control" value="" required>
                        </div>
                    </div>
                </div>
                <div class="form-group top">
                    <button class="btn btn-primary pull-right" type="button" id="form_submit"><i class="fa fa-check"></i>&nbsp;Display</button>
                </div>
            </form>
        </div>
    </div>
    <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="">Account Verification By Password</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <form id="modal-form">
                <div class="form-group">
                  <label for="recipient-name" class="col-form-label">Enter Report Password For the selected Account:</label>
                  <input type="password" class="form-control" name="password" id="password">
                </div>

            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              <button type="button" id="submitbutton" class="btn btn-primary">Verify</button>
            </div>
          </form>
          </div>
        </div>
    </div>
</div>
@endsection

@section('js')
<script>
    $('select[name="salesman_id"]').on('change', function(){
        var account_id = $(this).val();
        if(account_id) {
            CheckAccountPassword(account_id);
        } else {
        }
    });

    $("#form_submit").click(function(){
        
        if ($('#create_form').valid()) {
            var pass_check = $('#pass_check').val();
            if (pass_check == "no") {
                $('#create_form').submit();
            } else if(pass_check == "yes"){
                $('#exampleModal').modal('show');
            }
        }            
    });

    $("#submitbutton").click(function(){
        var password = $('#password').val();
        var account_master_id = $('#select_salesman').val();
        if (account_master_id == "") {
            alert("Kindly Select Account First");
        }else
        if (password != null){
            AccountPasswordVerfification(account_master_id, password);
        }
    });

    $(document).ready(function() {
        $('.input-group.date').datepicker({
            startView: 1,
            todayBtn: "linked",
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true,
            format: "yyyy-mm-dd"
        }).datepicker('setDate',new Date());
    });
            function showDate(){
                var select_type=$('#report_type').val();
                if(select_type=='date_wise'){
                    $('#show_date').show();
                }
                else{
                    $('#show_date').hide();
                }
            }
            function showReport(){
                var select_type=$('#report_type').val();
                if(select_type=='date_wise'){
                window.location.href="salesman-report-datewise";
                }
                else{
                    window.location.href="salesman-report-monthwise";
                }
            }


    $(document).ready(function () {
    $("#customer_info_btn").click(function () {
    $("#customer_info").toggle();
    });
});
</script>
@endsection
