<!DOCTYPE html>
<html>
<head>
<style>
table {
  font-family: arial, sans-serif;
  border-collapse: collapse;
  width: 100%;
}

td, th {
  border: 1px solid #dddddd;
  text-align: left;
  padding: 8px;
}

tr:nth-child(even) {
  background-color: #dddddd;
}
</style>
</head>
<body>
<h2>Complete Stock Report</h2>
<h4>{{\Carbon\Carbon::parse($from_date)->format('d-m-Y')}} to {{\Carbon\Carbon::parse($to_date)->format('d-m-Y')}}</h4>
    <table>
        <tr>
            <th>Item Name</th>
            <th>QTY</th>
            <th>Unit</th>
            @if ($show_cost == 1)
                <th>Rate</th>
                <th>Net Amount</th>
            @endif
        </tr>

        @foreach ($groups as $group)
        @php
            $group_total_qty = 0;
            $group_total_amount = 0;
            $purchase_invoice = '';
        @endphp

        @foreach($group->item_names as $key => $item_name)
        @php
            $item_quantity = $item_name->purchase_sales_transfer_stock_tracks->where('item_name_id', $item_name->id)->sum('quantity');
            $item_amount = $item_name->purchase_sales_transfer_stock_tracks->where('item_name_id', $item_name->id)->where('quantity', '>', 0)->sum('amount');
        @endphp
        @if ($item_quantity > 0)
            <tr>
                <td>{{$item_name->name}}</td>
                <td>{{$item_quantity}}</td>
                <td>{{$item_name->units->unit}}</td>
                @if ($show_cost == 1)
                    <td>{{ number_format($item_amount /$item_quantity, $decimal, '.', '') }}</td>
                    <td>{{number_format($item_amount, $decimal, '.', '')}}</td>
                @endif
            </tr>
        @endif

        @foreach ($item_name->purchase_sales_transfer_stock_tracks as $key => $purchase_sales_transfer_stock_track)
            @if ($purchase_sales_transfer_stock_track->quantity != 0)
                @php
                    $purchase_invoice = $item_name->purchase_sales_transfer_stock_tracks->where('item_name_id', $purchase_sales_transfer_stock_track->item_name_id)->where('imei_serial_no', $purchase_sales_transfer_stock_track->imei_serial_no)->first();
                        if($purchase_invoice){
                            $group_rate_per_quantity = $purchase_invoice->rate_per_quantity;
                        }else{
                            $group_rate_per_quantity = 0;
                    }
                    $group_total_qty = $group_total_qty + $purchase_sales_transfer_stock_track->quantity;
                    $group_total_amount = $group_total_amount + $purchase_sales_transfer_stock_track->amount;
                @endphp
            @endif
        @endforeach

    @endforeach
        @if ($group_total_qty != 0)
        <tr>
            <td><strong>{{$group->name}}</strong></td>
            <td><strong>{{ $group_total_qty }}</strong></td>
            <td></td>
            @if ($show_cost == 1)
                <td></td>
                {{-- @if ($group_total_amount > 0 && $group_total_qty > 0)
                    <td><strong>{{ number_format($group_total_amount / $group_total_qty, $decimal, '.', '') }}</strong></td>
                @else
                    <td><strong>{{number_format(0, $decimal, '.', '')}}</strong></td>
                @endif --}}
                <td><strong>{{ number_format($group_total_amount, $decimal, '.', '') }}</strong></td>
            @endif
        </tr>
        @endif
    @endforeach

    </table>

</body>
</html>
